:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3154,_3148/_3150,_3158):-(retract(dynamicVersion(_3154,_3148/_3150,_3172))->true;true),asserta(dynamicVersion(_3154,_3148/_3150,_3158)).
prim_assertFact('Dynamic.Dynamic'(_3266),'Prelude.()'):-retract(dynamicTime(_3276)),_3290 is _3276+1,assertz(dynamicTime(_3290)),_3266=..[_3304,_3310,_3316,_3322|_3324],_3352=..[_3304,_3290,0|_3324],assertz(user:_3352),logDynamicEvent(_3310,assertz,_3352).
prim_retractFact('Dynamic.Dynamic'(_3454),_3460):-_3454=..[_3464,_3470,_3476,_3482|_3484],_3512=..[_3464,_3500,_3506|_3484],reloadNewestDynamicVersionOf(_3464),retract(dynamicTime(_3522)),_3536 is _3522+1,assertz(dynamicTime(_3536)),call(user:_3512),isInTimeInterval(_3522,_3500,_3506),!,_3586=..[_3464,_3500,_3522|_3484],retract(user:_3512),!,logDynamicEvent(_3470,retract,_3512),assertz(user:_3586),_3460='Prelude.True'.
prim_retractFact(_3752,'Prelude.False').
prim_getDynamicKnowledge(_3788):-reloadNewestDynamicVersions,dynamicTime(_3792),term2partcall('Dynamic.isKnownAtTime'(_3792),1,_3788),(compileWithSharing(function)->makeShare(_3788,_3814);_3814=_3788).
prim_isKnownAtTime(_3892,'Dynamic.Dynamic'(_3888),'Prelude.True'):-_3888=..[_3900,_3906,_3912,_3918|_3920],_3948=..[_3900,_3936,_3942|_3920],call(user:_3948),isInTimeInterval(_3892,_3936,_3942).
isInTimeInterval(_4040,_4042,_4044):-_4040>=_4042,(_4044=0->true;_4040=<_4044).
logDynamicEvent('Dynamic.Temporary',_4136,_4138):-!.
logDynamicEvent('Dynamic.Persistent',_4194,_4196):-_4196=..[_4200,_4206,_4212|_4214],_4242=..[_4200,0,0|_4214],_4260=..[_4194,_4242],user:dynamicPredInfo(_4200/_4268,_4274),logDynamic(_4260,_4274).
logDynamic(_4364,_4366):-dir2tmplockfile(_4366,_4372),lockWithFileIfNotInTransaction(_4372),executeWithFinalize((dir2logfile(_4366,_4382),open(_4382,append,_4390),writeq(_4390,_4364),put_code(_4390,46),nl(_4390),flush_output(_4390),close(_4390),addChangePid(_4366)),unlockWithFileIfNotInTransaction(_4372)).
executeWithFinalize(_4528,_4530):-on_exception(_4538,_4528,(call(_4530),printError(_4538),!,fail)),!,call(_4530).
executeWithFinalize(_4626,_4628):-call(_4628),!,fail.
prim_startTransaction(_4690):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4752,initTransaction(_4690),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4752),fail)),!.
initTransaction(_4834):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4838)),_4834 is _4838+1,assertz(dynamicTime(_4834)),logAllDynamicPreds(startTransaction(_4834)).
prim_commitTransaction(_4938,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4938)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5022):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5030),map1partialM(prim_dynamic:addChangePid(0),_5030),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5136):-findall(_5140,isDynamicDir(_5140),_5148),sort(_5148,_5136).
isDynamicDir(_5198):-user:dynamicPredInfo(_5202,_5198),\+_5198=''.
logAllDynamicPreds(_5264):-getDynamicDirs(_5268),map1partialM(prim_dynamic:logDynamic(_5264),_5268).
initializeDynamic:-user:dynamicPredInfo(_5328/_5330,_5336),initializeDynamic(_5336,_5328/_5330),fail.
initializeDynamic.
initializeDynamic('',_5406/_5408):-!,retractAllFacts(_5406/_5408).
initializeDynamic(_5482,_5476/_5478):-existsDirectory(_5482),!,checkDynSpec(_5482,_5476/_5478),setDynamicVersion(_5482,_5476/_5478,0),!.
initializeDynamic(_5584,_5586):-existsFile(_5584),!,appendAtom('ERROR: Directory "',_5584,_5598),appendAtom(_5598,'" for dynamic entries cannot be created!',_5606),writeErr(_5606),nlErr,!,fail.
initializeDynamic(_5704,_5698/_5700):-upDirectory(_5704,_5712),(existsDirectory(_5712)->createDynamicDir(_5704,_5698/_5700),setDynamicVersion(_5704,_5698/_5700,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5704),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5890,_5892):-atom_codes(_5890,_5898),append(_5908,[47|_5904],_5898),\+member(47,_5904),!,atom_codes(_5892,_5908).
upDirectory(_5998,'.').
checkDynSpec(_6040,_6034/_6036):-dir2specfile(_6040,_6048),existsFile(_6048),readPrologTermFile(_6048,_6058),dynamicSpec(_6034/_6036,_6058),!.
checkDynSpec(_6140,_6142):-appendAtom('ERROR: Directory "',_6140,_6150),appendAtom(_6150,'" contains no matching dynamic entries!',_6158),writeErr(_6158),nlErr,!,fail.
replayLogFile(_6244,_6238/_6240):-dir2tmplockfile(_6244,_6252),lockWithFileIfNotInTransaction(_6252),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6244,_6238/_6240),unlockWithFileIfNotInTransaction(_6252)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6360,_6354/_6356):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6360),writeErr('\'...'),nlErr;true),getRunTime(_6414),ensurePakcsVersion(_6360),dir2dbfile(_6360,_6424),dir2pofile(_6360,_6430),consultPrologorPOFile(_6424,_6430),dir2logfile(_6360,_6442),open(_6442,read,_6450),(atEndOfStream(_6450)->close(_6450);assert(replayStatus(unchanged)),repeat,on_exception(_6480,readAndReplay(_6450),((printError(_6480)->true;true),writeErr('ERROR during reading of '),writeErr(_6442),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6450),retract(replayStatus(_6544)),writeNewDatabaseIfChanged(_6354/_6356,_6360,_6544)),updateDynFactsIfNecessary(_6360,_6354/_6356),readDynamicVersion(_6360,_6616),setDynamicVersion(_6360,_6354/_6356,_6616),writeChangePids(_6360,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6650),_6660 is _6650-_6414,writeErr(_6660),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6842):-readPAKCSVersion(_6842,_6848),_6848=pakcsVersion(_6852,_6854),prologMajor(_6864),\+_6864=_6854,dir2pofile(_6842,_6880),(existsFile(_6880)->deleteFile(_6880);true),writePAKCSVersion(_6842),!.
ensurePakcsVersion(_6984).
isCurrentPakcsVersion(_7010):-readPAKCSVersion(_7010,_7016),compilerVersion(_7020),!,(_7016=compilerVersion(_7020)->writePAKCSVersion(_7010);_7016=pakcsVersion(_7020,_7046)).
readPAKCSVersion(_7114,_7116):-dir2pakcsversionfile(_7114,_7122),existsFile(_7122),readPrologTermFile(_7122,_7116).
writePAKCSVersion(_7190):-dir2pakcsversionfile(_7190,_7196),compilerVersion(_7200),prologMajor(_7204),writePrologTermFile(_7196,pakcsVersion(_7200,_7204)).
updateDynFactsIfNecessary(_7272,_7274):-isCurrentPakcsVersion(_7272),!.
updateDynFactsIfNecessary(_7336,_7330/_7332):-compilerVersion(_7342),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7336),writeErr('\' to compiler version '),writeErr(_7342),writeErr(...),nlErr;true),updateDynFacts(_7330/_7332),writeNewDatabaseIfChanged(_7330/_7332,_7336,changed),writePAKCSVersion(_7336).
updateDynFactsIfNecessary(_7508,_7510).
updateDynFacts(_7544/_7546):-functor(_7554,_7544,_7546),functor(_7562,_7544,_7546),retract(user:_7554),arg(1,_7554,_7584),arg(1,_7562,_7584),arg(2,_7554,_7600),arg(2,_7562,_7600),translateDynFactArgs(3,_7546,_7554,_7562),asserta(user:_7562),fail.
updateDynFacts(_7720).
translateDynFactArgs(_7746,_7748,_7750,_7752):-_7746>_7748,!.
translateDynFactArgs(_7826,_7828,_7830,_7832):-arg(_7826,_7830,_7840),translateDynFactArg(_7840,_7846),arg(_7826,_7832,_7846),_7864 is _7826+1,translateDynFactArgs(_7864,_7828,_7830,_7832).
translateDynFactArg(_7962,_7962):-var(_7962),!.
translateDynFactArg(_8020,_8020):-number(_8020),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8558,_8560):-atomic(_8558),atom_codes(_8558,[40|_8570]),!,append("Prelude.(",_8570,_8592),atom_codes(_8560,_8592).
translateDynFactArg(_8668,_8670):-atom(_8668),atom_codes(_8668,[39|_8680]),!,(_8680=[_8690]->char_int(_8670,_8690);_8680=[78,85,76]->char_int(_8670,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8832,_8832):-atomic(_8832),!.
translateDynFactArg(_8890,_8892):-functor(_8890,_8898,_8900),translateDynFactArg(_8898,_8906),functor(_8892,_8906,_8900),translateDynFactArgs(1,_8900,_8890,_8892).
writeNewDatabaseIfChanged(_8988/_8990,_8996,changed):-!,dir2dbfile(_8996,_9004),dir2pofile(_8996,_9010),dir2logfile(_8996,_9016),appendAtom(_9004,'.bak',_9024),tell(_9024),writeq((:-dynamic _8988/_8990)),put_code(46),nl,listing(user:_8988/_8990),told,try_save_predicates(_8988/_8990,_9010),renameFile(_9024,_9004),appendAtom(_9016,'.bak',_9092),renameFile(_9016,_9092),appendAtom('touch ',_9016,_9106),shellCmd(_9106),readDynamicVersion(_8996,_9116),_9126 is _9116+1,writeDynamicVersion(_8996,_9126),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9336/_9338,_9344,_9346):-dir2logfile(_9344,_9352),appendAtom(_9352,'.bak',_9360),renameFile(_9352,_9360),appendAtom('touch ',_9352,_9374),shellCmd(_9374).
readAndReplay(_9456):-atEndOfStream(_9456),!.
readAndReplay(_9504):-read(_9504,_9510),replayEvent(_9504,_9510).
replayEvent(_9560,end_of_file):-!.
replayEvent(_9612,startTransaction(_9608)):-readAndReplayTransaction(_9612,_9608,[]),!,fail.
replayEvent(_9680,_9682):-retract(replayStatus(_9686)),assert(replayStatus(changed)),call(user:_9682),!,fail.
readAndReplayTransaction(_9778,_9780,_9782):-atEndOfStream(_9778),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9780),nlErr;true).
readAndReplayTransaction(_9890,_9892,_9894):-read(_9890,_9900),(_9900=commitTransaction(_9892)->callRevList(_9894);_9900=abortTransaction->true;readAndReplayTransaction(_9890,_9892,[_9900|_9894])),!.
callRevList([]).
callRevList([_10050|_10052]):-callRevList(_10052),retract(replayStatus(_10064)),assert(replayStatus(changed)),call(user:_10050).
startTransaction(_10142).
commitTransaction(_10168).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10206),map1M(prim_dynamic:lockDynamicDir,_10206).
lockDynamicDir(_10252):-dir2lockfile(_10252,_10258),lockWithFile(_10258).
lockWithFileIfNotInTransaction(_10306):-insideTransaction->true;lockWithFile(_10306).
lockWithFile(_10360):-appendAtom('lockfile-create --lock-name ',_10360,_10368),(existsFile(_10360),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10360),writeErr('\'...'),nlErr;true),shellCmd(_10368),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10486),map1M(prim_dynamic:unlockDynamicDir,_10486).
unlockDynamicDir(_10532):-dir2lockfile(_10532,_10538),unlockWithFile(_10538).
unlockWithFileIfNotInTransaction(_10586):-insideTransaction->true;unlockWithFile(_10586).
unlockWithFile(_10640):-existsFile(_10640),!,appendAtom('lockfile-remove --lock-name ',_10640,_10652),shellCmd(_10652).
unlockWithFile(_10712).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10738/_10740,_10746),dynamicVersion(_10746,_10738/_10740,_10766),reloadNewestDynamicVersion(_10746,_10738/_10740,_10766),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10838):-dynamicVersion(_10848,_10838/_10844,_10852),!,reloadNewestDynamicVersion(_10848,_10838/_10844,_10852).
reloadNewestDynamicVersionOf(_10916).
reloadNewestDynamicVersion(_10948,_10942/_10944,0):-!,retractAllFacts(_10942/_10944),replayLogFile(_10948,_10942/_10944),!.
reloadNewestDynamicVersion(_11052,_11046/_11048,_11056):-readDynamicVersion(_11052,_11062),\+_11056=_11062,!,retractAllFacts(_11046/_11048),replayLogFile(_11052,_11046/_11048),!.
reloadNewestDynamicVersion(_11178,_11180,_11182):-readChangePids(_11178,_11188),currentPID(_11192),(_11188=[];_11188=[_11192]),!.
reloadNewestDynamicVersion(_11294,_11288/_11290,_11298):-retractAllFacts(_11288/_11290),replayLogFile(_11294,_11288/_11290).
createDynamicDir(_11386,_11380/_11382):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11386),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11386,_11444),shellCmd(_11444),dir2logfile(_11386,_11454),appendAtom('touch ',_11454,_11462),shellCmd(_11462),dir2dbfile(_11386,_11472),appendAtom('touch ',_11472,_11480),shellCmd(_11480),dir2specfile(_11386,_11490),dynamicSpec(_11380/_11382,_11502),writePrologTermFile(_11490,_11502),writePAKCSVersion(_11386).
readPrologTermFile(_11630,_11632):-open(_11630,read,_11640),read(_11640,_11632),close(_11640).
writePrologTermFile(_11708,_11710):-open(_11708,write,_11718),writeq(_11718,_11710),put_code(_11718,46),nl(_11718),flush_output(_11718),close(_11718).
readDynamicVersion(_11818,_11820):-dir2versionfile(_11818,_11826),existsFile(_11826),!,on_exception(_11846,readPrologTermFile(_11826,_11820),_11820=0).
readDynamicVersion(_11914,1).
writeDynamicVersion(_11950,_11952):-dir2versionfile(_11950,_11958),writePrologTermFile(_11958,_11952).
readChangePids(_12016,_12018):-dir2changepidsfile(_12016,_12024),existsFile(_12024),!,on_exception(_12050,readPrologTermFile(_12024,_12018),_12018=[0]).
readChangePids(_12118,[]).
writeChangePids(_12154,_12156):-dir2changepidsfile(_12154,_12162),writePrologTermFile(_12162,_12156).
addChangePid(_12220):-currentPID(_12224),addChangePid(_12224,_12220).
addChangePid(_12274,_12276):-readChangePids(_12276,_12282),(member(_12274,_12282)->true;writeChangePids(_12276,[_12274|_12282])),!.
dynamicSpec(_12370/_12372,dynamicPredicate(_12370,_12372)).
retractDeadDynamicFacts(_12418/_12420):-length(_12428,_12420),_12440=..[_12418|_12428],_12428=[_12446,_12452|_12454],dynamicTime(_12464),call(user:_12440),_12452>0,_12464>_12452,retract(user:_12440),fail.
retractDeadDynamicFacts(_12582).
dir2logfile(_12608,_12610):-appendAtom(_12608,'/eventlog',_12610).
dir2lockfile(_12664,_12666):-appendAtom(_12664,'/LOCK',_12666).
dir2tmplockfile(_12720,_12722):-appendAtom(_12720,'/LOCK',_12722).
dir2dbfile(_12776,_12778):-appendAtom(_12776,'/database.pl',_12778).
dir2pofile(_12832,_12834):-appendAtom(_12832,'/dbpred.po',_12834).
dir2specfile(_12888,_12890):-appendAtom(_12888,'/spec',_12890).
dir2pakcsversionfile(_12944,_12946):-appendAtom(_12944,'/pakcsversion',_12946).
dir2versionfile(_13000,_13002):-appendAtom(_13000,'/version',_13002).
dir2changepidsfile(_13056,_13058):-appendAtom(_13056,'/changepids',_13058).
