%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_1447368])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1465192]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_1482932,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1482932]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_1500852,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1500852]),'TCons'('RedBlackTree.RedBlackTree',[_1500852])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_1518856,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1518856]),'TCons'('RedBlackTree.RedBlackTree',[_1518856])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1537022]),'TCons'([],[_1537022]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_1554732]),'TCons'('RedBlackTree.RedBlackTree',[_1554732]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1572724]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1572724]),'TCons'('RedBlackTree.RedBlackTree',[_1572724])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1590908]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1590908]),'TCons'('RedBlackTree.RedBlackTree',[_1590908])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1609086]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_1609086]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_1651370,_1651372,_1651374):-freeze(_1651372,'blocked_Set.empty'(_1651370,_1651372,_1651374)).
'blocked_Set.empty'(_1651686,_1651692,_1651698):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_1651686,_1651692,_1651698).

'Set.null'(_1653018,_1653020,_1653022):-freeze(_1653020,'blocked_Set.null'(_1653018,_1653020,_1653022)).
'blocked_Set.null'(_1653094,_1653100,_1653106):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_1653094,_1653100,_1653106).

'Set.elem'(_1653806,_1653808,_1653810,_1653812):-freeze(_1653810,'blocked_Set.elem'(_1653806,_1653808,_1653810,_1653812)).
'blocked_Set.elem'(_1653882,_1654136,_1654142,_1654148):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_1653882])),_1654136,_1654142,_1654148).

'Set.insert'(_1655432,_1655434,_1655436):-freeze(_1655434,'blocked_Set.insert'(_1655432,_1655434,_1655436)).
'blocked_Set.insert'(_1655508,_1655514,_1655520):-hnf(partcall(2,'RedBlackTree.update',[]),_1655508,_1655514,_1655520).

'Set.delete'(_1656298,_1656300,_1656302):-freeze(_1656300,'blocked_Set.delete'(_1656298,_1656300,_1656302)).
'blocked_Set.delete'(_1656374,_1656380,_1656386):-hnf(partcall(2,'RedBlackTree.delete',[]),_1656374,_1656380,_1656386).

'Set.toList'(_1657164,_1657166,_1657168):-freeze(_1657166,'blocked_Set.toList'(_1657164,_1657166,_1657168)).
'blocked_Set.toList'(_1657240,_1657246,_1657252):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_1657240,_1657246,_1657252).

'Set.fromList'(_1658120,_1658122,_1658124):-freeze(_1658122,'blocked_Set.fromList'(_1658120,_1658122,_1658124)).
'blocked_Set.fromList'(_1658356,_1658362,_1658368):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_1658356,_1658362,_1658368).

'Set.union'(_1659396,_1659398,_1659400,_1659402):-freeze(_1659400,'blocked_Set.union'(_1659396,_1659398,_1659400,_1659402)).
'blocked_Set.union'(_1659472,_1659806,_1659812,_1659818):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_1659472,'Set.insert']),'Set.toList'),_1659806,_1659812,_1659818).

'Set.intersect'(_1661324,_1661326,_1661328,_1661330,_1661332):-freeze(_1661330,'blocked_Set.intersect'(_1661324,_1661326,_1661328,_1661330,_1661332)).
'blocked_Set.intersect'(_1661410,_1661428,_1662148,_1662154,_1662160):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_1661428,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_1661410))),_1662148,_1662154,_1662160).

'Set.disjoint'(_1664520,_1664522,_1664524,_1664526,_1664528):-freeze(_1664526,'blocked_Set.disjoint'(_1664520,_1664522,_1664524,_1664526,_1664528)).
'blocked_Set.disjoint'(_1664606,_1664624,_1664944,_1664950,_1664956):-hnf('Prelude.apply'('Set.null','Set.intersect'(_1664606,_1664624)),_1664944,_1664950,_1664956).

:-costCenters(['']).




%%%%% Number of shared variables: 0
